# How to JWx That

Here you will find bits and pieces of code explaining how to perform certain Javascript Object Signing and Encryption (JOSE) operations using [`github.com/lestrrat-go/jwx/v2`](https://github.com/lestrrat-go/jwx/tree/v2).

If you would rather see code, try the [examples directory](../examples)

* [Anatomy of JOSE](./00-anatomy.md)
* [Working with JWT](./01-jwt.md)
* [Working with JWS](./02-jws.md)
* [Working with JWE](./03-jwe.md)
* [Working with JWK](./04-jwk.md)
* [Global Settings](./20-global-settings.md)
* [Integrating With Frameworks](./21-frameworks.md)
* [Frequently Asked Questions](./99-faq.md)
